<?php
/* Copyright (C) 2012 libertyernie

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE. */
if (!array_key_exists('base',$_REQUEST)) {
	echo "Error: please specify the base .rel (<tt>base</tt>)";
	die();
}
if (!array_key_exists('replace',$_REQUEST)) {
	echo "Error: please specify the .rel to be replaced (<tt>replace</tt>)";
	die();
}
$base = $_REQUEST['base'];
$replace = $_REQUEST['replace'];
$item = -1;
if (array_key_exists('item',$_REQUEST)) {
	$item = $_REQUEST['item'];
	if ($base != 'st_otrain.rel') {
		echo 'You cannot change items when the base is not st_otrain.rel &ndash; you selected: ' . $base;
		die();
	}
}
$region = 'RSBE';
if (array_key_exists('region',$_REQUEST)) {
	$region = $_REQUEST['region'];
}

$id_array = array(
	'st_battle.rel' => 1,
	'st_final.rel' => 2,
	'st_dolpic.rel' => 3,
	'st_mansion.rel' => 4,
	'st_mariopast.rel' => 5,
	'st_kart.rel' => 6,
	'st_donkey.rel' => 7,
	'st_jungle.rel' => 8,
	'st_pirates.rel' => 9,
	'st_norfair.rel' => 11,
	'st_orpheon.rel' => 12,
	'st_crayon.rel' => 13,
	'st_halberd.rel' => 14,
	'st_starfox.rel' => 19,
	'st_stadium.rel' => 20,
	'st_tengan.rel' => 21,
	'st_fzero.rel' => 22,
	'st_ice.rel' => 23,
	'st_gw.rel' => 24,
	'st_emblem.rel' => 25,
	'st_madein.rel' => 28,
	'st_earth.rel' => 29,
	'st_palutena.rel' => 30,
	'st_famicom.rel' => 31,
	'st_newpork.rel' => 32,
	'st_village.rel' => 33,
	'st_metalgear.rel' => 34,
	'st_greenhill.rel' => 35,
	'st_pictchat.rel' => 36,
	'st_plankton.rel' => 37,
	'st_config.rel' => 38,
	'st_dxshrine.rel' => 41,
	'st_dxyorster.rel' => 42,
	'st_dxgarden.rel' => 43,
	'st_dxonett.rel' => 44,
	'st_dxgreens.rel' => 45,
	'st_dxpstadium.rel' => 46,
	'st_dxrcruise.rel' => 47,
	'st_dxcorneria.rel' => 48,
	'st_dxbigblue.rel' => 49,
	'st_dxzebes.rel' => 50,
	'st_oldin.rel' => 51,
	'st_homerun.rel' => 52,
	'st_stageedit.rel' => 53,
	'st_heal.rel' => 54,
	'st_otrain.rel' => 55,
	'st_tbreak.rel' => 56,
	'st_customXX.rel' => 0,
);
if (!array_key_exists($base,$id_array)) {
	echo "Error: " . $base . " is not a valid input .rel";
	die();
}
if (!array_key_exists($replace,$id_array)) {
	echo "Error: " . $replace . " is not a valid input .rel";
	die();
}
$base_id = $id_array[$base];
$replace_id = $id_array[$replace];

$contents = file_get_contents($region . "/" . $base);
if ($contents == FALSE) {
	echo "Error: file " . $base . " not found in the " . $region . " folder on the server";
	die();
}

$tofind = chr(0x38) . chr(0xa5) . chr(0) . chr(0) . chr(0x38) . chr(0x80) . chr(0) . chr($base_id);
$offset = strpos($contents, $tofind);
if ($offset <= -1) {
	echo "Error: could not find offset to patch &ndash; is this the right .rel?";
	die();
}

$offset += 7;
$contents[$offset] = chr($replace_id);

if ($base == 'st_otrain.rel' && item != -1) {
	$numbers = array(1223, 1371, 1347, 1627);
	foreach ($numbers as $val) {
		if ($contents[$val] == chr(0x31)) {
			$contents[$val] = chr($item);
		} else {
			echo 'Error in st_otrain.rel: byte at ' . $val . ' was not 0x31';
			die();
		}
	}
}

header("Content-type: application/x-brawl-module");
header("Content-Disposition: attachment;filename=" . $replace);
echo $contents;
?>